%global common_desc %{expand:
OpenStack Compute (codename Nova) is open source software designed to provision and manage large
networks of virtual machines, creating a redundant and scalable cloud computing platform. It gives
you the software, control panels, and APIs required to orchestrate a cloud, including running
instances, managing networks, and controlling access through users and projects. OpenStack Compute
strives to be both hardware and hypervisor agnostic, currently supporting a variety of standard
hardware configurations and seven major hypervisors.}

Summary:       OpenStack Compute (nova)
Name:          openstack-nova
Version:       23.1.0
Release:       2%{?dist}
License:       ASL 2.0
URL:           http://openstack.org/projects/compute
Source0:       https://tarballs.openstack.org/nova/nova-%{version}.tar.gz
Source1:       nova-dist.conf
Source2:       nova.logrotate
Source3:       openstack-nova-api.service
Source4:       openstack-nova-compute.service
Source5:       openstack-nova-scheduler.service
Source6:       openstack-nova-metadata-api.service
Source7:       openstack-nova-conductor.service
Source8:       openstack-nova-spicehtml5proxy.service
Source9:       openstack-nova-novncproxy.service
Source10:      openstack-nova-serialproxy.service
Source11:      openstack-nova-os-compute-api.service
Source12:      nova-ifc-template
Source13:      nova-sudoers
Source14:      openstack-nova-novncproxy.sysconfig
Source15:      policy.json
Source16:      nova_migration-sudoers
Source17:      nova-ssh-config
Source18:      nova-migration-wrapper
Source19:      nova_migration_identity
Source20:      nova_migration_authorized_keys
Source21:      nova_migration-rootwrap.conf
Source22:      nova_migration-rootwrap_cold_migration

Patch0001:     backport-Adapt-to-SQLAlchemy-1.4.patch
Patch3000:     0001-downgrade-the-version-of-qemu-from-4.2.0-to-4.1.0.patch

BuildRequires: intltool python3-devel git-core python3-oslo-cache python3-os-traits python3-setuptools
BuildRequires: python3-netaddr python3-pbr python3-six python3-oslo-i18n python3-cryptography python3-oslo-policy
BuildRequires: python3-barbicanclient python3-ddt python3-ironicclient python3-os-testr python3-os-vif
BuildRequires: python3-oslo-rootwrap python3-oslotest python3-osprofiler python3-subunit python3-testrepository
BuildRequires: python3-testresources python3-testscenarios python3-tooz python3-oslo-vmware python3-cursive
BuildRequires: python3-os-service-types python3-os-resource-classes python3-requests-mock
BuildRequires: /usr/bin/pathfix.py
Requires:      openstack-nova-compute = %{version}-%{release}
Requires:      openstack-nova-scheduler = %{version}-%{release}
Requires:      openstack-nova-api = %{version}-%{release}
Requires:      openstack-nova-conductor = %{version}-%{release}
Requires:      openstack-nova-novncproxy = %{version}-%{release}
Requires:      openstack-nova-migration = %{version}-%{release}
BuildArch:     noarch

%description
%{common_desc}

%package common
Summary:          Components common to all OpenStack Nova services
BuildRequires:    systemd python3-castellan python3-glanceclient python3-keystonemiddleware python3-microversion-parse
BuildRequires:    python3-os-brick python3-oslo-db python3-oslo-reports python3-oslo-service
BuildRequires:    python3-oslo-versionedobjects python3-paramiko python3-babel python3-lxml python3-websockify
Requires:         python3-nova = %{version}-%{release}
%{?systemd_ordering}
Requires(pre):    shadow-utils

%description common
%{common_desc}

This package contains scripts, config and dependencies shared between all the OpenStack nova services.

%package compute
Summary:          OpenStack Nova Virtual Machine control service
Requires: openstack-nova-common = %{version}-%{release}
Requires: curl iscsi-initiator-utils iptables iptables-services ipmitool /usr/bin/virsh openssh-clients rsync
Requires: lvm2 python3-cinderclient genisoimage sg3_utils sysfsutils libosinfo python3-libguestfs python3-libvirt
Requires(pre):    qemu
Requires(pre):    qemu-block-rbd
Requires(pre):    qemu-block-ssh
Requires(pre):    python3-libvirt
Requires(pre):    libvirt-daemon-driver-nodedev
Requires(pre):    libvirt-daemon-driver-nwfilter
Requires(pre):    libvirt-daemon-driver-secret
Requires(pre):    libvirt-daemon-driver-qemu
Requires(pre):    libvirt-daemon-driver-storage-core

%description compute
%{common_desc}

This package contains the Nova service for controlling Virtual Machines.

%package scheduler
Summary:          OpenStack Nova VM distribution service
Requires:         openstack-nova-common = %{version}-%{release}

%description scheduler
%{common_desc}

This package contains the service for scheduling where to run Virtual Machines in the cloud.

%package api
Summary:          OpenStack Nova API services
Requires:         openstack-nova-common = %{version}-%{release} python3-cinderclient

%description api
%{common_desc}

This package contains the Nova services providing programmatic access.

%package conductor
Summary:          OpenStack Nova Conductor services
Requires:         openstack-nova-common = %{version}-%{release}

%description conductor
%{common_desc}

This package contains the Nova services providing database access for the compute service

%package novncproxy
Summary:          OpenStack Nova noVNC proxy service
Requires:         openstack-nova-common = %{version}-%{release}
Requires:         novnc python3-websockify

%description novncproxy
%{common_desc}

This package contains the Nova noVNC Proxy service that can proxy VNC traffic over browser websockets connections.

%package spicehtml5proxy
Summary:          OpenStack Nova Spice HTML5 console access service
Requires:         openstack-nova-common = %{version}-%{release} python3-websockify

%description spicehtml5proxy
%{common_desc}

This package contains the Nova services providing the spice HTML5 console access service to Virtual Machines.

%package serialproxy
Summary:          OpenStack Nova serial console access service

Requires:         openstack-nova-common = %{version}-%{release} python3-websockify

%description serialproxy
%{common_desc}

This package contains the Nova services providing the serial console access service to Virtual Machines.

%package migration
Summary:          OpenStack Nova Migration
Requires:         openstack-nova-compute = %{version}-%{release}

%description migration
%{common_desc}

This package contains scripts and config to support VM migration in Nova.

%package -n       python3-nova
Summary:          Nova Python libraries
Requires: openssl openssh sudo python3-paramiko python3-eventlet python3-iso8601 python3-netaddr python3-boto
Requires: python3-stevedore python3-sqlalchemy python3-alembic python3-routes python3-webob python3-castellan
Requires: python3-cryptography python3-cursive python3-dataclasses python3-glanceclient python3-greenlet
Requires: python3-keystonemiddleware python3-keystoneauth1 python3-jinja2 python3-jsonschema
Requires: python3-microversion-parse python3-neutronclient python3-novaclient python3-openstacksdk
Requires: python3-os-brick python3-os-resource-classes python3-os-traits python3-oslo-cache
Requires: python3-oslo-concurrency python3-oslo-config python3-oslo-context python3-oslo-db python3-oslo-i18n
Requires: python3-oslo-log python3-oslo-messaging python3-oslo-middleware python3-oslo-policy
Requires: python3-oslo-privsep python3-oslo-reports python3-oslo-rootwrap python3-oslo-serialization
Requires: python3-oslo-service python3-oslo-upgradecheck python3-oslo-utils python3-oslo-versionedobjects
Requires: python3-os-vif python3-oslo-vmware python3-pbr python3-prettytable python3-psutil python3-requests
Requires: python3-rfc3986 python3-taskflow python3-tooz python3-os-service-types python3-dateutil
Requires: python3-futurist python3-decorator python3-lxml python3-ldap python3-memcached
Requires: python3-paste python3-paste-deploy python3-netifaces python3-retrying python3-yaml

%description -n   python3-nova
%{common_desc}

This package contains the nova Python library.

%prep
%autosetup -n nova-%{version} -p1

find . \( -name .gitignore -o -name .placeholder \) -delete

find nova -name \*.py -exec sed -i '/\/usr\/bin\/env python/{d;q}' {} +
rm -rf *requirements.txt

%build
PYTHONPATH=. oslo-config-generator --config-file=etc/nova/nova-config-generator.conf
PYTHONPATH=. oslopolicy-sample-generator --config-file=etc/nova/nova-policy-generator.conf

%{py3_build}

%{__python3} setup.py compile_catalog -d build/lib/nova/locale -D nova

sed -i 's|group/name|group;name|; s|\[DEFAULT\]/|DEFAULT;|' etc/nova/nova.conf.sample
sed -i '/^[^#[]/{s/^/#/; s/ //g}; /^#[^ ]/s/ = /=/' etc/nova/nova.conf.sample

while read name eq value; do
  test "$name" && test "$value" || continue
  sed -i "0,/^# *$name=/{s!^# *$name=.*!#$name=$value!}" etc/nova/nova.conf.sample
done < %{SOURCE1}

%install
%{py3_install}

export PYTHONPATH=.
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/buckets
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/instances
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/keys
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/networks
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/tmp
install -d -m 750 %{buildroot}%{_localstatedir}/log/nova
install -d -m 700 %{buildroot}%{_sharedstatedir}/nova/.ssh

install -d -m 755 %{buildroot}%{_sysconfdir}/nova
install -p -D -m 640 %{SOURCE1} %{buildroot}%{_datarootdir}/nova/nova-dist.conf
install -p -D -m 640 etc/nova/nova.conf.sample  %{buildroot}%{_sysconfdir}/nova/nova.conf
install -p -D -m 640 etc/nova/rootwrap.conf %{buildroot}%{_sysconfdir}/nova/rootwrap.conf
install -p -D -m 640 etc/nova/api-paste.ini %{buildroot}%{_sysconfdir}/nova/api-paste.ini
install -d -m 755 %{buildroot}%{_sysconfdir}/nova/migration
install -p -D -m 600 %{SOURCE19} %{buildroot}%{_sysconfdir}/nova/migration/identity
install -p -D -m 644 %{SOURCE20} %{buildroot}%{_sysconfdir}/nova/migration/authorized_keys
install -p -D -m 640 %{SOURCE21} %{buildroot}%{_sysconfdir}/nova/migration/rootwrap.conf
install -d -m 755 %{buildroot}%{_sysconfdir}/nova/migration/rootwrap.d
install -p -D -m 640 %{SOURCE22} %{buildroot}%{_sysconfdir}/nova/migration/rootwrap.d/cold_migration.filters

install -p -D -m 640 %{SOURCE15} %{buildroot}%{_sysconfdir}/nova/policy.json

cat > %{buildroot}%{_sysconfdir}/nova/release <<EOF
[Nova]
product = OpenStack Compute
package = %{release}
EOF

install -p -D -m 644 %{SOURCE3} %{buildroot}%{_unitdir}/openstack-nova-api.service
install -p -D -m 644 %{SOURCE4} %{buildroot}%{_unitdir}/openstack-nova-compute.service
install -p -D -m 644 %{SOURCE5} %{buildroot}%{_unitdir}/openstack-nova-scheduler.service
install -p -D -m 644 %{SOURCE6} %{buildroot}%{_unitdir}/openstack-nova-metadata-api.service
install -p -D -m 644 %{SOURCE7} %{buildroot}%{_unitdir}/openstack-nova-conductor.service
install -p -D -m 644 %{SOURCE8} %{buildroot}%{_unitdir}/openstack-nova-spicehtml5proxy.service
install -p -D -m 644 %{SOURCE9} %{buildroot}%{_unitdir}/openstack-nova-novncproxy.service
install -p -D -m 644 %{SOURCE10} %{buildroot}%{_unitdir}/openstack-nova-serialproxy.service
install -p -D -m 644 %{SOURCE11} %{buildroot}%{_unitdir}/openstack-nova-os-compute-api.service

rm -f %{buildroot}%{_bindir}/nova-network

install -p -D -m 440 %{SOURCE13} %{buildroot}%{_sysconfdir}/sudoers.d/nova
install -p -D -m 440 %{SOURCE16} %{buildroot}%{_sysconfdir}/sudoers.d/nova_migration

install -p -D -m 600 %{SOURCE17} %{buildroot}%{_sharedstatedir}/nova/.ssh/config

install -p -D -m 755 %{SOURCE18} %{buildroot}%{_bindir}/nova-migration-wrapper

pathfix.py -pni "%{__python3} %{py3_shbang_opts}" %{buildroot}%{_bindir}/nova-migration-wrapper

install -p -D -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-nova

install -d -m 755 %{buildroot}%{_localstatedir}/run/nova

install -p -D -m 644 %{SOURCE12} %{buildroot}%{_datarootdir}/nova/interfaces.template

mkdir -p %{buildroot}%{_datarootdir}/nova/rootwrap/
install -p -D -m 644 etc/nova/rootwrap.d/* %{buildroot}%{_datarootdir}/nova/rootwrap/

install -d %{buildroot}%{_sysconfdir}/sysconfig
install -p -m 0644 %{SOURCE14} %{buildroot}%{_sysconfdir}/sysconfig/openstack-nova-novncproxy

install -d -m 755 %{buildroot}%{_datadir}
rm -f %{buildroot}%{python3_sitelib}/nova/locale/*/LC_*/nova*po
rm -f %{buildroot}%{python3_sitelib}/nova/locale/*pot
mv %{buildroot}%{python3_sitelib}/nova/locale %{buildroot}%{_datadir}/locale

%find_lang nova --all-name

rm -f %{buildroot}%{_bindir}/nova-debug
rm -fr %{buildroot}%{python3_sitelib}/run_tests.*
rm -f %{buildroot}%{_bindir}/nova-combined
rm -f %{buildroot}/usr/share/doc/nova/README*

rm -rf %{buildroot}%{_prefix}/etc/nova

%check

%pre common
getent group nova >/dev/null || groupadd -r nova --gid 162
if ! getent passwd nova >/dev/null; then
  useradd -u 162 -r -g nova -G nova,nobody -d %{_sharedstatedir}/nova -s /sbin/nologin -c "OpenStack Nova Daemons" nova
fi
exit 0

%pre compute
usermod -a -G qemu nova
usermod -a -G libvirt nova
%pre migration
getent group nova_migration >/dev/null || groupadd -r nova_migration
getent passwd nova_migration >/dev/null || \
    useradd -r -g nova_migration -d / -s /bin/bash -c "OpenStack Nova Migration" nova_migration
exit 0

%post compute
%systemd_post %{name}-compute.service

%preun compute
%systemd_preun %{name}-compute.service

%postun compute
%systemd_postun_with_restart %{name}-compute.service

%post scheduler
%systemd_post %{name}-scheduler.service

%preun scheduler
%systemd_preun %{name}-scheduler.service

%postun scheduler
%systemd_postun_with_restart %{name}-scheduler.service

%post api
%systemd_post %{name}-api.service %{name}-metadata-api.service %{name}-os-compute-api.service

%preun api
%systemd_preun %{name}-api.service %{name}-metadata-api.service %{name}-os-compute-api.service

%postun api
%systemd_postun_with_restart %{name}-api.service %{name}-metadata-api.service %{name}-os-compute-api.service

%post conductor
%systemd_post %{name}-conductor.service

%preun conductor
%systemd_preun %{name}-conductor.service

%postun conductor
%systemd_postun_with_restart %{name}-conductor.service

%post novncproxy
%systemd_post %{name}-novncproxy.service

%preun novncproxy
%systemd_preun %{name}-novncproxy.service

%postun novncproxy
%systemd_postun_with_restart %{name}-novncproxy.service

%post spicehtml5proxy
%systemd_post %{name}-spicehtml5proxy.service

%preun spicehtml5proxy
%systemd_preun %{name}-spicehtml5proxy.service

%postun spicehtml5proxy
%systemd_postun_with_restart %{name}-spicehtml5proxy.service

%post serialproxy
%systemd_post %{name}-serialproxy.service

%preun serialproxy
%systemd_preun %{name}-serialproxy.service

%postun serialproxy
%systemd_postun_with_restart %{name}-serialproxy.service

%files

%files common -f nova.lang
%license LICENSE
%doc etc/nova/policy.yaml.sample
%dir %{_datarootdir}/nova
%attr(-, root, nova) %{_datarootdir}/nova/nova-dist.conf
%{_datarootdir}/nova/interfaces.template
%dir %{_sysconfdir}/nova
%{_sysconfdir}/nova/release
%config(noreplace) %attr(-, root, nova) %{_sysconfdir}/nova/nova.conf
%config(noreplace) %attr(-, root, nova) %{_sysconfdir}/nova/api-paste.ini
%config(noreplace) %attr(-, root, nova) %{_sysconfdir}/nova/rootwrap.conf
%config(noreplace) %attr(-, root, nova) %{_sysconfdir}/nova/policy.json
%config(noreplace) %{_sysconfdir}/logrotate.d/openstack-nova
%config(noreplace) %{_sysconfdir}/sudoers.d/nova
%dir %attr(0750, nova, root) %{_localstatedir}/log/nova
%dir %attr(0755, nova, root) %{_localstatedir}/run/nova
%{_bindir}/nova-manage
%{_bindir}/nova-policy
%{_bindir}/nova-rootwrap
%{_bindir}/nova-rootwrap-daemon
%{_bindir}/nova-status

%defattr(-, nova, nova, -)
%dir %{_sharedstatedir}/nova
%dir %{_sharedstatedir}/nova/buckets
%dir %{_sharedstatedir}/nova/instances
%dir %{_sharedstatedir}/nova/keys
%dir %{_sharedstatedir}/nova/networks
%dir %{_sharedstatedir}/nova/tmp

%files compute
%{_unitdir}/openstack-nova-compute.service
%{_bindir}/nova-compute
%{_datarootdir}/nova/rootwrap/compute.filters

%files scheduler
%{_unitdir}/openstack-nova-scheduler.service
%{_bindir}/nova-scheduler

%files api
%{_unitdir}/openstack-nova-*api.service
%{_bindir}/nova-api*
%{_bindir}/nova-metadata-wsgi

%files conductor
%{_unitdir}/openstack-nova-conductor.service
%{_bindir}/nova-conductor

%files novncproxy
%{_unitdir}/openstack-nova-novncproxy.service
%config(noreplace) %{_sysconfdir}/sysconfig/openstack-nova-novncproxy
%{_bindir}/nova-novncproxy

%files spicehtml5proxy
%{_unitdir}/openstack-nova-spicehtml5proxy.service
%{_bindir}/nova-spicehtml5proxy

%files serialproxy
%{_unitdir}/openstack-nova-serialproxy.service
%{_bindir}/nova-serialproxy

%files migration
%config(noreplace) %{_sysconfdir}/sudoers.d/nova_migration
%dir %attr(0700, nova, nova) %{_sharedstatedir}/nova/.ssh
%attr(0600, nova, nova) %{_sharedstatedir}/nova/.ssh/config
%dir %{_sysconfdir}/nova/migration
%config(noreplace) %attr(0640, root, nova_migration) %{_sysconfdir}/nova/migration/authorized_keys
%config(noreplace) %attr(0600, nova, nova) %{_sysconfdir}/nova/migration/identity
%config(noreplace) %attr(0640, root, root) %{_sysconfdir}/nova/migration/rootwrap.conf
%dir %{_sysconfdir}/nova/migration/rootwrap.d
%config(noreplace) %attr(0640, root, root) %{_sysconfdir}/nova/migration/rootwrap.d/cold_migration.filters
%{_bindir}/nova-migration-wrapper

%files -n python3-nova
%license LICENSE
%{python3_sitelib}/nova
%{python3_sitelib}/nova-*.egg-info

%changelog
* Wed May 17 2023 Shuo Wang <abushwang@tencent.com> - 23.1.0-2
- backport patch: Adapt to SQLAlchemy 1.4

* Fri May 5 2023 Shuo Wang <abushwang@tencent.com> - 23.1.0-1
- initial build
